<?php

if (!defined('IN_AJAX')) die(basename(__FILE__));

global $lang, $bb_cfg, $userdata, $datastore;

$url = (string) $this->request['url'];
$url = str_replace('http://www.', 'http://', $url);

$dir = $bb_cfg['pic_dir'] .'gallery/'. date("m-Y");
if (!file_exists($dir))
{
    mkdir($dir, 0777);
}
$allowed_ext = array('jpeg', 'jpg', 'png', 'gif');

if (preg_match("#http://.*?.onliner.by/#", $url))
{
    $content = file_get_contents($url);
    $content = html_entity_decode($content);

    $pos = strpos($content, '<div class="b-post-tags-1">');
    $content = substr($content, $pos);
    if(!$content) $this->ajax_die('Не удалось получить контент');

    preg_match_all ("#<h3 class=\"b-posts-1-item__title\"><a href=\".*?\" ><span>([\s\S]*?)</span></a></h3>#", $content, $source, PREG_SET_ORDER);
	$subject = addslashes($source[0][1]);
    
	if(!$subject) $this->ajax_die('Не удалось найти тему');
	
	//echo $this->ajax_die($subject);

    $row = DB()->fetch_row("SELECT topic_id FROM ". BB_TOPICS ." WHERE topic_title = '$subject'");
    if($row)
    {
        $this->response['url'] = make_url(TOPIC_URL . $row['topic_id']);
    }
    else
    {
        preg_match_all ("#<figure class=\"b-posts-1-item__image\">([\s\S]*?)<footer class=\"b-inner-pages-footer-1\">#", $content, $source, PREG_SET_ORDER);
        $message = $source[0][1];
		
		preg_match_all ('/<img.*?src="(.*?)".*? \/>/', $message, $pic);
        if(count($pic[1]))
        {
            foreach ($pic[1] as $img)
            {
                $filetype = substr(strrchr($img, '.'), 1);
                if (@fopen($img, "r") && in_array($filetype, $allowed_ext))
                {
                    $filename = substr($img, strrpos($img, '/'));
                    copy($img, $dir . $filename);
                    $new_img = make_url($dir . $filename);
                    $message = str_replace($img, $new_img, $message);
                }
            }
        }
		
		$message = preg_replace('/<p style="text-align: (.*?);">([\s\S]*?)<\/p>/', "[align=\\1]\\2[/align]", $message);
    	$message = str_replace('</p>', "\n", $message);
    	$message = str_replace('<p>', '', $message);
    	$message = str_replace('<strong>', '[b]', $message);
    	$message = str_replace('</strong>', '[/b]', $message);
    	$message = str_replace('<em>', '[i]', $message);
    	$message = str_replace('</em>', '[/i]', $message);

    	$message = preg_replace('/<a href="http:\/\/.*?.onliner.by\/.*?" target="_blank">(.*?)<\/a>/', '\\1', $message);
    	$message = preg_replace('/<a href="(.*?)" target="_blank">(.*?)<\/a>/', "[url=\\1]\\2[/url]", $message);
		$message = preg_replace('/<a href=".*?">(.*?)<\/a>/', '\\1', $message);
    	$message = preg_replace('/<img.*? src="(.*?)" .*?\/>/', "[align=center][img]\\1[/img][/align]", $message);
        $message = preg_replace('/<iframe src="http:\/\/www.youtube.com\/embed\/(.*?)\?rel=0".*?">.*?<\/iframe>/', 'http://www.youtube.com/watch?v=\\1', $message);
        $message = preg_replace('/<iframe src="http:\/\/www.youtube.com\/embed\/(.*?)".*?">.*?<\/iframe>/', 'http://www.youtube.com/watch?v=\\1', $message);
        $message = '[size=14]'. $message .'[/size]';
		
		//echo $this->ajax_die($message);
		
		if($message = addslashes(strip_tags($message)))
        {
			$topic_id = array();
            $post_id = array();
		    submit_topic($subject, $message, 4, $topic_id, $post_id);
			
			// чистка кеша новостий сети
			if($bb_cfg['show_network_news'])
	        {
		        $datastore->enqueue('network_news');
			    $datastore->update('network_news');
	        }
			// чистка кеша последних сообщений
			if($bb_cfg['new_post']) CACHE('bb_cache')->rm('new_post');
        }
        else $this->ajax_die('Ошибка. Обратитесь к администратору');
    }
}
elseif (preg_match("#http://iguides.ru/#", $url))
{
    $content = file_get_contents($url);
    $content = html_entity_decode($content);

    $pos = strpos($content, '<div id=\"post_message_.*?\" class=\".*?\">');
    $content = substr($content, $pos);
    $pos = strpos($content, '<div style="padding: 10px;"');
    $content = substr($content, 0, $pos);
    if(!$content) $this->ajax_die('Не удалось получить контент');

    preg_match_all ("#<div class=\"tcat_news\">([\s\S]*?)</div>#", $content, $source, PREG_SET_ORDER);
	$subject = addslashes($source[0][1]);
    
	if(!$subject) $this->ajax_die('Не удалось найти тему');
	
	//echo $this->ajax_die($subject);

    $row = DB()->fetch_row("SELECT topic_id FROM ". BB_TOPICS ." WHERE topic_title = '$subject'");
    if($row)
    {
        $this->response['url'] = make_url(TOPIC_URL . $row['topic_id']);
    }
    else
    {
        preg_match_all ("#<div id=\"post_message_.*?\" class=\".*?\">([\s\S]*?)</td>#", $content, $source, PREG_SET_ORDER);
        $message = $source[0][1];

    	$message = preg_replace('/<a href=".*?" class="highslide" onclick=".*?" target="_blank"><img src="(.*?)".*? \/><\/a>/', "[align=center][img]\\1[/img][/align]", $message);

        $message = '[size=14]'. $message .'[/size]';
		
		//echo $this->ajax_die($message);
		
		if($message = addslashes(strip_tags($message)))
        {
			$topic_id = array();
            $post_id = array();
		    submit_topic($subject, $message, 4, $topic_id, $post_id);
			
			// чистка кеша новостий сети
			if($bb_cfg['show_network_news'])
	        {
		        $datastore->enqueue('network_news');
			    $datastore->update('network_news');
	        }
			// чистка кеша последних сообщений
			if($bb_cfg['new_post']) CACHE('bb_cache')->rm('new_post');
        }
        else $this->ajax_die('Ошибка. Обратитесь к администратору');
    }
}
elseif (preg_match("#http://gameland.ru/news/#", $url))
{
    $content = file_get_contents($url);
    $content = html_entity_decode(iconv('windows-1251', 'UTF-8', $content));

    $pos = strpos($content, '<div class="blocks2_corner">');
    $content = substr($content, $pos);
    /*$pos = strpos($content, '<div class="blocks2_corner">');
    $content = substr($content, 0, $pos);*/
    if(!$content) $this->ajax_die('Не удалось получить контент');

    preg_match_all ("#<h1>([\s\S]*?)</h1>#", $content, $source, PREG_SET_ORDER);
	$subject = addslashes($source[0][1]);
    
	if(!$subject) $this->ajax_die('Не удалось найти тему');
	
	//$this->ajax_die($subject);

    $row = DB()->fetch_row("SELECT topic_id FROM ". BB_TOPICS ." WHERE topic_title = '$subject'");
    if($row)
    {
        $this->response['url'] = make_url(TOPIC_URL . $row['topic_id']);
    }
    else
    {
        preg_match_all("#<tr><td.*?width=\"100%\">([\s\S]*?)</td></tr></table></div></div>#", $content, $source, PREG_SET_ORDER);
        $message = $source[0][1];

		$message = preg_replace('/<p style="text-align: (.*?);">([\s\S]*?)<\/p>/', "[align=\\1]\\2[/align]", $message);
    	$message = preg_replace('/<p>(.*?)<\/p>/', "$1\n", $message);
    	$message = preg_replace('/<strong>(.*?)<\/strong>/', '[b]$1[/b]', $message);
		$message = preg_replace('/<em.*?>(.*?)<\/em>/', '[i]\\1[/i]', $message);

		$message = preg_replace('/<a.*?href="\/(.*?)".*?>(.*?)<\/a>/', '[url=http://gameland.ru/$1]$2[/url]', $message);
		$message = preg_replace('/<a.*?>.*?last="1" src="(.*?)"><\/a>/', '[align=center][img]http://gameland.ru$1[/img][/align]', $message);

        $message = preg_replace('/<a.*?href="(.*?)".*?>(.*?)<\/a>/', '[url=$1]$2[/url]', $message);

        $message = '[size=14]'. $message .'[/size]';
		
		//$this->ajax_die($message);
		
		if($message = addslashes(strip_tags($message)))
        {
			$topic_id = array();
            $post_id = array();
		    submit_topic($subject, $message, 4, $topic_id, $post_id);
			
			// чистка кеша новостий сети
			if($bb_cfg['show_network_news'])
	        {
		        $datastore->enqueue('network_news');
			    $datastore->update('network_news');
	        }
			// чистка кеша последних сообщений
			if($bb_cfg['new_post']) CACHE('bb_cache')->rm('new_post');
        }
        else $this->ajax_die('Ошибка. Обратитесь к администратору');
    }
}
elseif (preg_match("#http://habrahabr.ru/#", $url))
{
    $content = file_get_contents($url);
    $content = html_entity_decode($content);

    $pos = strpos($content, '<h1 class="title">');
    $content = substr($content, $pos);
    $pos = strpos($content, '<ul class="tags"');
    $content = substr($content, 0, $pos);
    if(!$content) $this->ajax_die('Не удалось получить контент');

    preg_match_all ("#<span class=\"post_title\">([\s\S]*?)</span>#", $content, $source, PREG_SET_ORDER);
	$subject = addslashes($source[0][1]);
    
	if(!$subject) $this->ajax_die('Не удалось найти тему');
	
	//$this->ajax_die($subject);

    $row = DB()->fetch_row("SELECT topic_id FROM ". BB_TOPICS ." WHERE topic_title = '$subject'");
    if($row)
    {
        $this->response['url'] = make_url(TOPIC_URL . $row['topic_id']);
    }
    else
    {
        preg_match_all("#<div class=\"content html_format\">([\s\S]*?)</div>#", $content, $source, PREG_SET_ORDER);
        $message = $source[0][1];

    	$message = str_replace('<b>', '[b]', $message);
    	$message = str_replace('</b>', '[/b]', $message);
		$message = str_replace('<s>', '[s]', $message);
    	$message = str_replace('</s>', '[/s]', $message);
		$message = str_replace('<u>', '[u]', $message);
    	$message = str_replace('</u>', '[/u]', $message);
		$message = preg_replace('/<em.*?>(.*?)<\/em>/', '[i]\\1[/i]', $message);
    	$message = str_replace('<br/>', "\n", $message);
    	$message = str_replace('<pre>', '[pre]', $message);
    	$message = str_replace('</pre>', '[/pre]', $message);
    	$message = preg_replace('/<code.*?>/', '[code]', $message);
    	$message = str_replace('</code>', '[/code]', $message);

		$message = preg_replace('/<a href="(.*?)".*?>(.*?)<\/a>/', "[url=\\1]\\2[/url]", $message);
		$message = preg_replace('/<a href="(.*?)".*?><img src="(.*?)".*?\/><\/a>/', "[url=\\1][img]\\2[/img][/url]", $message);
		$message = preg_replace('/<img src="(.*?)".*?\/>/', "[align=center][img]\\1[/img][/align]", $message);
		$message = preg_replace('/<iframe.*?src="http:\/\/www.youtube.com\/embed\/(.*?)".*?><\/iframe>/', "[youtube]http://www.youtube.com/watch?v=\\1[/youtube]", $message);
		
        $message = '[size=14]'. $message .'[/size]';
		
		//$this->ajax_die($message);
		
		if($message = addslashes(strip_tags($message)))
        {
			$topic_id = array();
            $post_id = array();
		    submit_topic($subject, $message, 4, $topic_id, $post_id);
			
			// чистка кеша новостий сети
			if($bb_cfg['show_network_news'])
	        {
		        $datastore->enqueue('network_news');
			    $datastore->update('network_news');
	        }
			// чистка кеша последних сообщений
			if($bb_cfg['new_post']) CACHE('bb_cache')->rm('new_post');
        }
        else $this->ajax_die('Ошибка. Обратитесь к администратору');
    }
}
elseif (preg_match("#http://allgamenews.net/#", $url))
{
    $content = file_get_contents($url);
    $content = html_entity_decode(iconv('windows-1251', 'UTF-8', $content));

    $pos = strpos($content, '<div class="base fullstory">');
    $content = substr($content, $pos);
    $pos = strpos($content, '<div class="related"');
    $content = substr($content, 0, $pos);
    if(!$content) $this->ajax_die('Не удалось получить контент');

    preg_match_all ("#<h3 class=\"btl\">([\s\S]*?)</h3>#", $content, $source, PREG_SET_ORDER);
	$subject = addslashes($source[0][1]);
    
	if(!$subject) $this->ajax_die('Не удалось найти тему');
	
	//$this->ajax_die($subject);

    $row = DB()->fetch_row("SELECT topic_id FROM ". BB_TOPICS ." WHERE topic_title = '$subject'");
    if($row)
    {
        $this->response['url'] = make_url(TOPIC_URL . $row['topic_id']);
    }
    else
    {
        preg_match_all("#<div class=\"maincont\">([\s\S]*?)<div class=\"clr\"#", $content, $source, PREG_SET_ORDER);
        $message = $source[0][1];

    	$message = str_replace('<b>', '[b]', $message);
    	$message = str_replace('</b>', '[/b]', $message);
		$message = str_replace('<s>', '[s]', $message);
    	$message = str_replace('</s>', '[/s]', $message);
		$message = str_replace('<u>', '[u]', $message);
    	$message = str_replace('</u>', '[/u]', $message);
		$message = preg_replace('/<em.*?>(.*?)<\/em>/', '[i]\\1[/i]', $message);
    	$message = str_replace('<br />', "\n", $message);

		$message = preg_replace('/<span style="color:([^<]*?)">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $message);
		$message = preg_replace('/<span style="font-family:([^<]*?)">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $message);
		
		$message = preg_replace('/<a href="javascript:ShowOrHide.*?">([^<]*?)<\/a>/', "[spoiler=\"\\1\"]\n\\2\n[/spoiler]", $message);
		
		$message = preg_replace('/<a href="(.*?)".*?><img.*?\/><\/a>/', "[align=center][img]\\1[/img][/align]", $message);
		$message = preg_replace('/<img.*?src="(.*?)".*?\/>/', "[align=center][img]\\1[/img][/align]", $message);
		$message = preg_replace('/<a href="(.*?)".*?>(.*?)<\/a>/', "[url=\\1]\\2[/url]", $message);
		
		
        $message = '[size=14]'. $message .'[/size]';
		
		//$this->ajax_die($message);
		
		if($message = addslashes(strip_tags($message)))
        {
			$topic_id = array();
            $post_id = array();
		    submit_topic($subject, $message, 4, $topic_id, $post_id);
			
			// чистка кеша новостий сети
			if($bb_cfg['show_network_news'])
	        {
		        $datastore->enqueue('network_news');
			    $datastore->update('network_news');
	        }
			// чистка кеша последних сообщений
			if($bb_cfg['new_post']) CACHE('bb_cache')->rm('new_post');
        }
        else $this->ajax_die('Ошибка. Обратитесь к администратору');
    }
}
else $this->ajax_die('Ваш сайт не поддерживается');

//$this->response['url'] = make_url(TOPIC_URL . $topic_id);


function submit_topic($subject, $message, $forum_id, &$topic_id, &$post_id)
{
	global $bb_cfg, $userdata, $datastore;
	
	require(INC_DIR .'bbcode.php');
	require(INC_DIR .'functions_post.php');
	
    $user_ip = USER_IP;
    $user_id = $userdata['user_id'];
    $time = TIMENOW;
	
	$t_data = DB()->fetch_row("SELECT f.* FROM ". BB_FORUMS ." f WHERE f.forum_id = $forum_id");
	DB()->query("INSERT INTO ". BB_TOPICS ." (topic_title, topic_poster, topic_time, forum_id, topic_last_post_time) VALUES ('$subject', '$user_id', '$time', '$forum_id', '$time')");
	$topic_id = DB()->sql_nextid();

	DB()->query("INSERT INTO ". BB_POSTS ." (topic_id, forum_id, poster_id, post_time, poster_ip) VALUES ($topic_id, $forum_id, '$user_id', '$time', '$user_ip')");
	$post_id = DB()->sql_nextid();

	DB()->query("UPDATE ". BB_TOPICS ." SET topic_first_post_id = $post_id, topic_last_post_id = $post_id WHERE topic_id = $topic_id");

	$message = prepare_message($message, 1, 1);

	DB()->query("INSERT INTO ". BB_POSTS_TEXT ." (post_id, post_text) VALUES ($post_id, '$message')");
	DB()->query("UPDATE ". BB_FORUMS ." SET forum_posts = forum_posts + 1, forum_last_post_id = $post_id, forum_topics = forum_topics + 1 WHERE forum_id = $forum_id");

	add_search_words($post_id, stripslashes($message), stripslashes($subject));
    update_post_stats('newtopic', $t_data, $forum_id, $topic_id, $post_id, $userdata['user_id']);

	update_post_html(array(
		'post_id'        => $post_id,
		'post_text'      => $message,
	));
}
